#include <stdio.h>
#include <stdlib.h>
#include <stdint.h>
#include <string.h>
#include <fcntl.h>
#include <pthread.h>
#include <unistd.h>
#include <termios.h>
#include <mosquitto.h>
#include <cjson/cJSON.h>
#include <time.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <ifaddrs.h>
#include <wiringPi.h>
#include "gpio_pwm.h"
#include "main.h"
#include "ip.h"
#include "mqtt.h"
#include "delay.h"
#include "opensh.h"

char buffer[30]; // 用于存储文件内容

void *AppExit(void *arg)//出现意外自动停止
{ 
  
    while(1)
    {    
        Delay_Ms(0,100);
        gPwmCount++;
        gmessage_4_index++;
        if(gPwmCount>=5)
        {
        midde_pwm();
        gPwmCount=6;
        pin_all_default();
        } 
        if(gmessage_4_index>=150)//计时15s，15s才能远程刷新一次
        {
            gmessage_4_index=160;
        }

    }
    
    return NULL; 
}

void *Mqttbeat(void *arg)
{ 
    printf("Mqttbeat start\n");
    //Delay_Ms(15,0);
    //refresh_cam();//刷新cam
    Delay_Ms(15,0);
   
    while(1)
    {
        ipaddr();//获取ip
        Delay_Ms(3,0);
        mqtt_wirte();//心跳，3s一个        
    }

    return NULL;
}

void *opensh(void *arg)
{ 
    Delay_Ms(5,0);
    printf("open cam\n");
    opencamsh();//10s后打开游览器并且进入网址 
   return NULL; 
}

void *Mqtt_onnect(void *arg)//mqtt异常处理，断开自动重连，简单粗暴
{
    Delay_Ms(5,0);
    mqtt_init();//mqtt初始化
    mqtt_create(mosq);//创建mqtt客户端
    while(1)
    {
    mqtt_create(mosq);//创建mqtt客户端     
    mqtt_cycle(mosq); //进入mqtt死循环，异常退出继续执行while
    }
    mqtt_clean(mosq);
    return NULL;
}

char *device_inspect()//读出文件函数
{
    FILE *file;
    while (1) {
        file = fopen(filename, "r"); // 以只读模式打开文件

        if (file == NULL) 
        {
            printf("文件 %s 打开失败，等待中...\n", filename);
        } 
        else 
        {
            // 尝试读取文件内容
            if (fgets(buffer, sizeof(buffer), file) != NULL) 
            {
                // 如果文件内容不为空
                fclose(file);
                printf("读取到文件内容: %s\n", buffer);
                return  buffer;
            } 
            else 
            {
                printf("文件为空，等待中...\n");
            }
            fclose(file);
        }

        Delay_Ms(1,0); // 等待1秒后再次检查
    }
}

int main(int argc, char *argv[]) {

    if (wiringPiSetup() == -1) {
        printf("WiringPi setup failed!\n");
        return 1;
        }
    pin_init();
    pwm_speed(); //pwm初始化，车为停止
    Delay_Ms(60,0);

    const char *readbuf=device_inspect();

    TOPIC=malloc(24);
    TOPIC2=malloc(24);
    TOPIC3= malloc(16);

    //TOPIC3=device_inspect();//读取文件内容
    //sprintf(TOPIC3,"%s",buffer);
    //strcpy(TOPIC3,device_inspect());
    sprintf(TOPIC2,"dev2app/%s",readbuf);
    sprintf(TOPIC,"app2dev/%s",readbuf);
    sprintf(TOPIC3,"%s",readbuf);
    printf("1:%s,2:%s,3:%s\n",TOPIC,TOPIC2,TOPIC3);
    system("pkill chromium-browser");
    
    gStart=time(NULL);//开始时间戳
   

    ipaddr();//获取ip

    thread_start(AppExit,Mqttbeat,opensh,Mqtt_onnect);//开启线程
    
    thread_end();

    return EXIT_SUCCESS;
}